# Generated by Django 5.1.1 on 2024-09-12 05:05

import django.db.models.deletion
import uuid
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="CA",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=200)),
                ("key", models.TextField()),
                ("cert", models.TextField()),
                ("cert_print", models.JSONField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="Group",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=200)),
            ],
        ),
        migrations.CreateModel(
            name="Network",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=200, unique=True)),
                ("cidr", models.CharField(default="100.100.64.0/24", max_length=200)),
            ],
        ),
        migrations.CreateModel(
            name="Host",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=200)),
                ("assigned_ip", models.CharField(max_length=200)),
                ("is_lighthouse", models.BooleanField(default=False)),
                (
                    "public_ip_or_hostname",
                    models.CharField(blank=True, max_length=200, null=True),
                ),
                ("is_relay", models.BooleanField(default=False)),
                ("use_relay", models.BooleanField(default=True)),
                (
                    "public_key",
                    models.TextField(blank=True, max_length=1000, null=True),
                ),
                (
                    "public_auth_kid",
                    models.CharField(blank=True, max_length=200, null=True),
                ),
                (
                    "public_auth_key",
                    models.TextField(blank=True, max_length=1000, null=True),
                ),
                ("interface", models.CharField(default="nebula1", max_length=200)),
                ("groups", models.ManyToManyField(blank=True, to="networks.group")),
                (
                    "network",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="networks.network",
                    ),
                ),
            ],
            options={
                "unique_together": {("network", "name")},
            },
        ),
        migrations.CreateModel(
            name="HostCert",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("cert", models.TextField(max_length=1000)),
                ("hash", models.IntegerField(default=0)),
                (
                    "ca",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="networks.ca"
                    ),
                ),
                (
                    "host",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="networks.host"
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="HostConfig",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("config", models.TextField()),
                ("sha256", models.CharField(blank=True, max_length=200, null=True)),
                (
                    "host",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="networks.host"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="group",
            name="network",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="networks.network"
            ),
        ),
        migrations.AddField(
            model_name="ca",
            name="network",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="networks.network"
            ),
        ),
        migrations.CreateModel(
            name="SigningCA",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "ca",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="networks.ca"
                    ),
                ),
                (
                    "network",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="networks.network",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Template",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=200)),
                ("is_lighthouse", models.BooleanField(default=False)),
                ("is_relay", models.BooleanField(default=False)),
                ("use_relay", models.BooleanField(default=True)),
                (
                    "enrollment_key",
                    models.CharField(default=uuid.uuid4, max_length=255, unique=True),
                ),
                ("groups", models.ManyToManyField(blank=True, to="networks.group")),
                (
                    "network",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="networks.network",
                    ),
                ),
            ],
        ),
    ]
